/************************************************************************
 *
 * dlnew.c -- This file contains routines needed for creating
 *            doubly-linked lists.
 *
 ************************************************************************/

#include <malloc.h>
#include <stdio.h>
#include "dlpriv.h"

/************************************************************************
 *
 * dll_new -- Given a SETUP structure, this function creates an empty
 *            doubly-linked list.
 *
 ************************************************************************/

#ifdef __STDC__
DL_LIST dll_new(DLL_SETUP psetup)
#else
DL_LIST dll_new(psetup)
DLL_SETUP	psetup;
#endif
{
	LIST	*retval;
	SETUP	*setup;

	COVER("dlnew.c",1);
	if (psetup == NULL)
	{
		COVER("dlnew.c",2);
		return NULL;
	}
	setup = (SETUP*) psetup;
	retval = (LIST*) malloc(sizeof(LIST));
	if (retval != NULL)
	{
		COVER("dlnew.c",3);
		retval->last = NULL;
		retval->current = NULL;
		retval->data = setup->data;
		retval->comp = setup->comp;
		retval->nextOk = 0;
		retval->size = 0;
		retval->changed = 0;
	}
	COVER("dlnew.c",4);
	return (DL_LIST) retval;
}

/************* End of file **************/

